#include <stdio.h>
#include <stdlib.h>
#include "VectorUtilities.h"
#include "ManipVector.h"


bool PrintVctr(const int* v,const int size){
  int i;
  for (i=0; i<size; i++)
    {
      cout << *(v+i) << endl;
    }
  return true;
}

bool PrintVctr(const INT_VCTR_1D& V){
  if (V.size() == 0)
    {
      cout << "Uninitialized vector - PrintVctr" << endl;
      return false;
    }
  int i;
  for (i=0; i<(int)V.size(); i++){
    printf("%d\n",V[i]);
  }
  return true;
}

bool PrintVctr(const DBL_VCTR_1D& V){
  if (V.size() == 0)
    {
      cout << "Uninitialized vector - PrintVctr" << endl;
      return false;
    }
  int i;
  for (i=0; i<(int)V.size(); i++){
    printf("%f  \n",V[i]);
  }
  return true;
}

bool PrintVctr(const INT_VCTR_2D& V){
  if (V.size() == 0 || V[0].size() == 0)
    {
      cout << "Uninitialized vector - PrintVctr" << endl;
      return false;
    }
  int i,j;
  for (i=0;i<(int)V.size();i++){
    for (j=0;j<(int)V[0].size();j++){
      printf("%d  ",V[i][j]);
    }
    printf("\n");
  }
  cout<<" "<<endl;
  return true;
}

bool PrintVctr(const DBL_VCTR_2D& V){
  if (V.size() == 0 || V[0].size() == 0)
    {
      cout << "Uninitialized vector - PrintVctr" << endl;
      return false;
    }
  int i,j;
  for (i=0;i<(int)V.size();i++)
    {
      for (j=0;j<(int)V[0].size();j++)
	{
	  printf("%f  ",V[i][j]);
	}
      printf("\n");
    }
  cout<<" "<<endl;
    return true;
}

bool PrintVctr(const INT_VCTR_3D& V){
  if (V.size() == 0 || V[0].size() == 0 ||  V[0][0].size() == 0)
    {
      cout << "Uninitialized vector - PrintVctr" << endl;
      return false;
    }
  int i;
  for (i=0;i<(int)V.size();i++)
    {
      PrintVctr(V[i]);
    }
  cout<<" "<<endl;
  return true;
}

bool PrintVctr(const DBL_VCTR_3D& V){
  if (V.size() == 0 || V[0].size() == 0 ||  V[0][0].size() == 0)
    {
      cout << "Uninitialized vector - PrintVctr" << endl;
      return false;
    }
  int i;
  for (i=0;i<(int)V.size();i++)
    {
      PrintVctr(V[i]);
    }
  cout<<" "<<endl;
  return true;
}



void CopyVctr(const DBL_VCTR_2D& v1,DBL_VCTR_2D& v2){
  // initialise seulement si v2 n'avait pas encore ete initialise
  // sinon copie en ecrivant "par dessus" v2
  int i;
  if ((int)v2.size()==0){
    for (i = 0; i < (int)v1.size(); i++){
      //printf("CopyVctr : v2 initialisation\n");
      v2.push_back(v1[i]);
    }
  }else{
    if (v2.size()!=v1.size()||v2[0].size()!=v1[0].size()){
      printf("CopyVctr : error, dimensions don't match. Exiting...\n");
      exit(1);
    }
    //printf("CopyVctr : v2 rewritted\n");
    for (i = 0; i < (int)v1.size(); i++) {
      v2[i]=v1[i];
    }
  }
}
