#ifndef __MATRIX_UTILITIES__
#define __MATRIX_UTILITIES__

#include "VectorUtilities.h"
#include "ManipVector.h"
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>



/********************************************************
 ***                 MATRIX UTILITIES                 ***
 ********************************************************/

// Cholesky decomposition
void choldc(DBL_VCTR_2D& matrix, const DBL_VCTR_2D mat);

//A%*%B (where B has only one column)
void Mult(DBL_VCTR_1D& Res, const DBL_VCTR_2D& A, const DBL_VCTR_1D& B);

//A%*%B
void Mult(DBL_VCTR_2D& Res, const DBL_VCTR_2D& A, const DBL_VCTR_2D& B);

//A%*%t(B)
void Mult_t(DBL_VCTR_2D& Res, const DBL_VCTR_2D& A, const DBL_VCTR_2D& B);

//t(A)%*%B
void Mult_t_left(DBL_VCTR_2D& Res, const DBL_VCTR_2D& A, const DBL_VCTR_2D& B);

// A ^(-1)
void Inverse(DBL_VCTR_2D& res, const DBL_VCTR_2D& A);

// t(A)
void Transpose(DBL_VCTR_2D& res, const DBL_VCTR_2D& A);

//search for max(W[i,-k],0)
double FindBound(const DBL_VCTR_1D& Wi, int k);

//Inverse function, using Choleski decompo (?)
void InverseWithChol(DBL_VCTR_2D& res, const DBL_VCTR_2D& A);

#endif
