#include <gsl/gsl_randist.h>
#include "MiscUtilities.h"

// The function selects a number from 0, 1, ..., nNum - 1 according to the probabilities
// stored in dW (nNum is the size of dW). Note that sum of dW must be 1.
int SelectANum(const gsl_rng* rng, const DBL_VCTR_1D& dW)
{
	double dU = gsl_rng_uniform_pos(rng);
	double dSum = 0.0;

	int i;
	for (i = 0; i < int(dW.size()); i++)
	{
		if (dSum < dU && dU <= dSum + dW[i])
		{
			break;
		}

		dSum += dW[i];
	}

	return i;
}
