#ifndef __RNG_UTILITIES__
#define __RNG_UTILITIES__

/*! \file RNGUtilities.h
 *  \brief Header File for Random Number Generator Routines
 */

#include <gsl/gsl_rng.h>

//! Allocating a Random Number Generator
/*! \param rng The Random Number Generator To Be Allocated
 *  \param type The Type of Random Number Generator
 *  \author Chibiao Chen
 */
void AllocRNG(gsl_rng*& rng, const gsl_rng_type* type);

//! Freeing an Allocated Random Number Generator
/*! \param rng The Random Number Generator To Be Freed
 *  \author Chibiao Chen
 */
void FreeRNG(gsl_rng*& rng);

#endif//__RNG_UTILITIES__
